unit mTBruch;

interface

uses mSuM;

type TBruch=class
    zZaehler: GanzeZahl;
    zNenner: GanzeZahl;
    constructor init(pZaehler, pNenner: GanzeZahl);
    procedure setzeZaehler(pZaehler : GanzeZahl);
    procedure setzeNenner(pNenner : GanzeZahl);
    function zaehler : GanzeZahl;
    function nenner : GanzeZahl;
    procedure kuerzeUm(pZahl : GanzeZahl);
    procedure erweitereUm(pZahl : GanzeZahl);
    procedure kuerzeVoll;
    function dezimalwert : Zahl;
    procedure kehrbruch;
    destructor gibFrei;

  private
    function ggt(pZahl1,pZahl2:GanzeZahl):GanzeZahl;
end;

implementation

constructor TBruch.init(pZaehler, pNenner : GanzeZahl);
begin
  zZaehler:=pZaehler;
  zNenner:=pNenner;
end;

procedure TBruch.setzeZaehler(pZaehler : GanzeZahl);
begin
  zZaehler:=pZaehler;
end;

procedure TBruch.setzeNenner(pNenner : GanzeZahl);
begin
  zNenner:=pNenner;
end;

function TBruch.zaehler : GanzeZahl;
begin
  result:=zZaehler;
end;

function TBruch.nenner : GanzeZahl;
begin
  result:=zNenner;
end;

procedure TBruch.kuerzeUm(pZahl : GanzeZahl);
begin
  zZaehler:=zZaehler div pZahl;
  zNenner:=zNenner div pZahl;
end;

procedure TBruch.erweitereUm(pZahl : GanzeZahl);
begin
  zZaehler:=zZaehler * pZahl;
  zNenner:=zNenner * pZahl;
end;

procedure TBruch.kuerzeVoll;
begin
 self.kuerzeUm(ggt(zZaehler,zNenner));
end;

function TBruch.dezimalwert : Zahl;
begin
  result:=zZaehler/zNenner;
end;

procedure TBruch.kehrbruch;
  var lTausch : GanzeZahl;
begin
  lTausch:=zZaehler;
  zZaehler:=zNenner;
  zNenner:=lTausch;
end;

destructor TBruch.gibFrei;
begin
end;

function TBruch.ggt(pZahl1,pZahl2:GanzeZahl):GanzeZahl;  //rekursiv
begin
  if pZahl1<0 then pZahl1:=-pZahl1;
  if pZahl2<0 then pZahl2:=-pZahl2;
  
  if pZahl1=pZahl2 then result:=pZahl1;
  if pZahl1>pZahl2 then result:=self.ggt(pZahl1-pZahl2, pZahl2);
  if pZahl1<pZahl2 then result:=self.ggt(pZahl1, pZahl2-pZahl1);
end;

{function TBruch.ggt(pZahl1,pZahl2:GanzeZahl):GanzeZahl;  // iterativ
begin
  while not(pZahl1=pZahl2) do
    if pZahl1<pZahl2
      then pZahl2:=pZahl2-pZahl1
      else pZahl1:=pZahl1-pZahl2;
  result := pZahl1;
end;}

end.

